<template>
  <div>
    <div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100 base-datatable filter-date"
         v-if="filter">
      <md-field :class="{'md-invalid': errors.has('start_date')}">
        <label>Start Date</label>
        <datetime-picker class="datetime-picker"
                         input-type="timestamp"
                         type="date"
                         data-vv-as="end time"
                         v-validate="'required'"
                         :max-datetime="filter.end_date"
                         @input="fetchData"
                         name="start_date"
                         v-model="filter.start_date"
                         format="yyyy-MM-dd">
        </datetime-picker>
        <span class="md-error" v-if="errors.has('start_date')">{{ errors.first('start_date') }}</span>
      </md-field>
      <md-field :class="{'md-invalid': errors.has('end_date')}">
        <label>End Date</label>
        <datetime-picker class="datetime-picker"
                         input-type="timestamp"
                         type="date"
                         data-vv-as="end time"
                         v-validate="'required'"
                         @input="fetchData"
                         name="end_date"
                         :min-datetime="filter.start_date"
                         v-model="filter.end_date"
                         format="yyyy-MM-dd">
        </datetime-picker>
        <span class="md-error" v-if="errors.has('end_date')">{{ errors.first('end_date') }}</span>
      </md-field>
    </div>
    <data-table ref="datatable" v-if="isFetchedFilter" :get-data="getConversionStatistic" :limit="10">
      <template slot="table-toolbar">
        <div class="md-toolbar-section-start">
          <h1 class="md-title">Conversions</h1>
        </div>
      </template>

      <md-table-head>DATE</md-table-head>
      <md-table-head>BTC</md-table-head>
      <md-table-head>ETH</md-table-head>
      <md-table-head>USDT</md-table-head>
      <md-table-head>HETA</md-table-head>
      <md-table-head>BONUS</md-table-head>

      <template slot="header-body">
        <md-table-row class="total">
          <md-table-cell>TOTAL</md-table-cell>
          <md-table-cell>{{ totalCurrency.btc | formatCurrencyAmount('btc', '0') }}</md-table-cell>
          <md-table-cell>{{ totalCurrency.eth | formatCurrencyAmount('eth', '0') }}</md-table-cell>
          <md-table-cell>{{ totalCurrency.usdt | formatCurrencyAmount('usdt', '0')}}</md-table-cell>
          <md-table-cell>{{ totalHeta | formatCurrencyAmount('heta', '0')}}</md-table-cell>
          <md-table-cell>{{ totalBonus | formatCurrencyAmount('heta', '0')}}</md-table-cell>
        </md-table-row>
      </template>

      <template v-if="isFetchedFilter" slot="body" slot-scope="{ item }">
        <md-table-row :key="item.created_day_london">
          <md-table-cell>{{ item.created_day_london }}</md-table-cell>
          <md-table-cell>{{ item.total_btc_amount | formatCurrencyAmount('btc', '0') }}</md-table-cell>
          <md-table-cell>{{ item.total_eth_amount | formatCurrencyAmount('eth', '0') }}</md-table-cell>
          <md-table-cell>{{ item.total_usdt_amount | formatCurrencyAmount('usdt', '0')}}</md-table-cell>
          <md-table-cell>{{ item.token_amount | formatCurrencyAmount('heta', '0')}}</md-table-cell>
          <md-table-cell>{{ item.bonus_amount | formatCurrencyAmount('heta', '0')}}</md-table-cell>
        </md-table-row>
      </template>

    </data-table>

    <div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100 base-datatable">
      <md-card class="md-card-plain">
        <md-card-content>
          <highcharts v-if="isFetchedFilter" :options="chartOptions" ref="highcharts"></highcharts>
        </md-card-content>
      </md-card>
    </div>
  </div>
</template>

<script>
  import rf from '../../common/requests/RequestFactory';
  import bignumber from 'bignumber.js';
  import DatetimePicker from '../components/DatetimePicker.vue';
  import moment from 'moment';

  export default {
    components: {
      DatetimePicker
    },
    data () {
      return {
        filter: {},
        chartOptions: {
          chart: {
            type: 'column',
            backgroundColor: '#ffffff',
            height: '500px',
            marginTop: 80
          },

          title: {
            text: 'Spent VS Deposited',
          },

          plotOptions: {
            column: {
              stacking: 'normal',
            }
          },

          xAxis: {
            lineWidth: 1,
            lineColor: '#cccc',
            categories: ['BTC', 'ETH', 'USDT'],
          },

          yAxis: {
            min: 0,
            lineWidth: 1,
            lineColor: '#cccc',
            allowDecimals: true,
            title: {
              text: 'USD',
            },
            gridLineDashStyle: 'longdash',
          },

          series: [
            {
              name: 'Bonus',
              data: [],
              stack: '1',
              color: '#F8B886',
            },
            {
              name: 'Bought',
              data: [],
              stack: '1',
              color: '#F48039',
            },
            {
              name: 'Deposited',
              data: [],
              stack: '2',
              color: '#643A2B',
            }
          ]
        },
        totalCurrency: {},
        totalHeta: 0,
        totalBonus: 0,
      }
    },
    computed: {
      isFetchedFilter () {
        return this.filter && this.filter.start_date && this.filter.end_date;
      }
    },
    methods: {
      fetchData () {
        if (!this.isFetchedFilter) {
          return;
        }
        this.getSpentVsDepositedStatistic();
        this.$refs.datatable.refresh()
      },
      async getConversionStatistic (params) {
        if (!this.isFetchedFilter) {
          return new Promise(resolve => {
            return resolve({ meta: {}, data: [] });
          });
          return;
        }

        params = Object.assign({}, params, {
          start_at: moment(this.filter.start_date, 'x').utcOffset(1).startOf('day').valueOf(),
          end_at: moment(this.filter.end_date, 'x').utcOffset(1).endOf('day').valueOf(),
        });
        return rf.getRequest('StatisticRequest').getConversionStatistic(params);
      },
      getSpentVsDepositedStatistic () {
        let params = {};
        if (this.filter.start_date && this.filter.end_date) {
          params = {
            start_at: moment(this.filter.start_date, 'x').utcOffset(1).startOf('day').valueOf(),
            end_at: moment(this.filter.end_date, 'x').utcOffset(1).endOf('day').valueOf(),
          };
        }
        return rf.getRequest('StatisticRequest').getSpentVsDepositedStatistic(params).then(res => {
          let bonusDataset = [];
          let boughtDataset = [];
          let depositedDataset = [];

          this.totalHeta = 0;
          this.totalBonus = 0;

          _.forEach(res.data, (row) => {
            bonusDataset.push(row.bonus_usd_amount);
            depositedDataset.push(row.currency_usd_amount);
            boughtDataset.push(row.token_usd_amount);

            this.totalCurrency[row.currency] = row.currency_amount;
            this.totalHeta = bignumber(this.totalHeta).plus(row.token_amount).toString();
            this.totalBonus = bignumber(this.totalBonus).plus(row.bonus_amount).toString();
          });

          this.chartOptions.series = [
            {
              name: 'Bonus',
              data: [],
              stack: '1',
              color: '#F8B886',
            },
            {
              name: 'Bought',
              data: [],
              stack: '1',
              color: '#F48039',
            },
            {
              name: 'Deposited',
              data: [],
              stack: '2',
              color: '#643A2B',
            }];
        });
      },
      getSystemSettings () {
        rf.getRequest('SystemSettingRequest').getAll().then(res => {
          this.filter = {
            start_date: res.data.ico_start_time,
            end_date: res.data.ico_end_time
          };
          this.$nextTick(() => {
            this.getSpentVsDepositedStatistic();
          });
        });
      },
    },
    mounted () {
      this.getSystemSettings();
    }
  }
</script>

<style lang="scss" scoped>
  .total {
    color: rgba(0, 0, 0, 0.54);
    font-weight: 600;
  }

  .filter-date {
    padding: 0px 40px;
    width: 1000px !important;
    max-width: 1000px !important;
    min-width: 1000px !important;
    display: inline-block;
    font-size: 0;
    float: right;
    .md-field {
      width: 45%;
      display: inline-block;
      .datetime-picker {
        margin-top: 33px;
      }
    }
  }
</style>

